package jp.co.nanoconnect.boundball;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

public class BoundBallActivity extends Activity implements SensorEventListener {
    
	/** ZT}l[W[ */
	private SensorManager mSensorManager;
	/** `p̃r[NX */
	private BoundBallView mBallView;
	/** ZT̒l\TextView */
	private TextView mSensorValuesView;
	
	/** s */
	private static final String BR = System.getProperty("line.separator");
	/** Oo͗p̃^O */
	private static final String LOG_TAG = "BoundBalls";

	
	/* ActivityƂɌĂ΂郁\bh  */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }
    
	/* Activity\钼OɌĂ΂郁\bh */
	@Override
	protected void onResume() {
		mBallView = (BoundBallView) findViewById(R.id.view_bound_balls);
		mSensorValuesView = (TextView) findViewById(R.id.text_values);

		/* SensorManager̎擾 */
		mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
		/* [ɓڂĂZT̎擾 */
		List<Sensor> sensors = mSensorManager.getSensorList(Sensor.TYPE_ALL);
		for (Sensor s : sensors) {
			Log.d(LOG_TAG, s.getName() + " : type = " + s.getType());
			/* ZTXĩZbg */
			if (s.getType() == Sensor.TYPE_ACCELEROMETER) {
				mSensorManager.registerListener(this, s,
						SensorManager.SENSOR_DELAY_GAME);
			}
		}
		super.onResume();
	}

	/* ZT̐xɕωƂɌĂ΂郁\bh */
	@Override
	public void onAccuracyChanged(Sensor sensor, int i) {
		Log.d(LOG_TAG, "onAccuracyChanged. accuracy = " + i);
	}

	/* ZT̒lɕωƂɌĂ΂郁\bh */
	@Override
	public void onSensorChanged(SensorEvent sensorevent) {
		/* ZTl̎擾  */
		if (sensorevent.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
			mBallView.setAcceleration(sensorevent.values);
			showSensorValues(sensorevent.values);
		}
	}

	/**
	 * ZT̒lʏɕ\郁\bh
	 * @param values ZT̒l
	 */
	private void showSensorValues(float[] values) {
		if (values == null) return;
		NumberFormat nf = new DecimalFormat("0.0000");
		StringBuilder sb = new StringBuilder();
		sb.append("x-axis(m/s^2) = ").append(nf.format(values[0]))
				.append(BR).append("y-axis(m/s^2) = ")
				.append(nf.format(values[1])).append(BR)
				.append("z-axis(m/s^2) = ").append(nf.format(values[2]));
		mSensorValuesView.setText(sb.toString());
	}
}